exports.__esModule = true;
exports.default = _asyncToGenerator;

function _asyncToGenerator(fn) {
  return function () {
    var _this = this,
        _arguments = arguments;

    return new Promise(function (resolve, reject) {
      var gen = fn.apply(_this, _arguments);

      function step(key, arg) {
        try {
          var info = gen[key](arg);
          var value = info.value;
        } catch (error) {
          reject(error);
          return;
        }

        if (info.done) {
          resolve(value);
        } else {
          Promise.resolve(value).then(_next, _throw);
        }
      }

      function _next(value) {
        step("next", value);
      }

      function _throw(err) {
        step("throw", err);
      }

      _next();
    });
  };
}